#!/bin/sh

service_name=p1-reader

while getopts a:r: flag
do
    case "${flag}" in
        a) added_device=${OPTARG};;
        r) removed_device=${OPTARG};;
    esac
done

if [[ ! -z "$removed_device" ]]
then
	device_count=0

	find /dev -name 'ttyUSB*' -print | while read file
	do
		device_count=$((device_count+1))
		echo "$file"
	done

	if [ $device_count -gt 0 ]
	then
		rm -f /etc/runit/p1-reader/down
		sv start $service_name
	else
		touch /etc/runit/p1-reader/down
		sv down $service_name
	fi
fi

if [[ ! -z "$added_device" ]]
then
	rm -f /etc/runit/p1-reader/down
	sv start $service_name
fi
