# General

Tries to automate the steps described here:
https://redmine.digitalstrom.org/projects/dss/wiki/How_to_build_the_dSS

First you need to checkout [ds-os](https://git.digitalstrom.org/dss/ds-os).
Start with the Readme of ds-os. Do not start with dss-mainline checkout.

After checkout of ds-os, you will have a dss-mainline folder. Change into that
folder and continue with this Reamde from  there. This will be your new
dss-mainline main checkout folder.


# Build and start a new docker container for compiling

External dependenices are built from gitlab-ci, we download the finished docker image.
Make sure you can login to the gitlab docker repository. This is handled automatically from
build-container.sh

```sh
    $ ./docker/build-container.sh
    Username: andreas.fenkart@dev.digitalstrom.org
    Password:
    WARNING! Your password will be stored unencrypted in /home/afenkart/.docker/config.json.
    Configure a credential helper to remove this warning. See
    https://docs.docker.com/engine/reference/commandline/login/#credentials-store

    Login Succeeded
    Sending build context to Docker daemon  336.9kB
    Step 1/12 : FROM git.digitalstrom.org:4567/dss/dss-mainline/base
    ...
```

Base image is defined here
[mainline-base-image](https://git.digitalstrom.org/dss-oe/helpers/tree/master/ci/docker/dss-mainline/base)


Start and explore the newly created container

```sh
    ./docker/run-container.sh
```

*docker/vhome* is mounted as virtual home directory inside the docker.
Copy git configuraion and personal settings there

  -- vhome (folder within docker/vhome )
    | -- ds-os (ds-os checkout)
        | -- dss-mainline (subfolder from ds-os checkout)

You have sudo rights inside the container, so you can quickly add missing a packet.

> password less sudo rights within the container is insecure


If you need to check if your local shell is a docker container

```sh
    afenkart@muskel:~/dSS/ds-os/dss-mainline$ systemd-detect-virt
    docker
```

> Note systemd-detect-virt not installed currently, so...

Leave the contain again using *exit*

> You can create copy Dockerfile.{USER} and customize it with your local needs

To force delete the image:

```sh
    docker rmi dss-mainline
```

# Build digitalStrom dependencies

These are not yet part of the base image:
- ds485 stack (client + dsm-api)
- libcommchannel (dsa/dss communication)

We are still relying on the
[env](https://redmine.digitalstrom.org/projects/dss/wiki/How_to_build_the_dSS#Building-the-dS485-Stack)
script trick

But we arleady provided one inside of the docker/ folder. So don't need create one
if you followed the directory structure above.
Just instantiate the container and from within the container run the compile script

```sh
    ./docker/run-container.sh
    ./docker/compile-ds485.sh
```

> You only need to do this in the beginning and whenever there are changes in these projects


# Build dSS mainline

Evtl. check the README.md in the dss-mainline root folder for changes, otherwise
everything should be installed and ready for building

```sh
    ./docker/run-container.sh
    ./docker/do_autotools.sh --configure
```

meson build is currently not finished


```sh
    ./docker/run-container.sh
    ./docker/do_meson.sh
```

# run dSS mainline

```sh
    ./docker/run-container.sh
    ./docker/run-dss.sh
```

> You need to type 'run' at the gdb prompt

The script, expects a ds485p port is accessible inside the container, not shown. You can also
replace the ip address inside the script

```sh
    ssh -S none -L8440:127.0.0.1:8440 target-dss
```

You can then access the dss under (http://localhost:8080)[http://localhost:8080]
