#!/bin/bash
set -e

DOCKER_DIR="$(dirname $(realpath $0))"
. ${DOCKER_DIR}/env.sh

if [ ! -d $PREFIX/share/dss/data/logs/ ]; then
    make -C build-autoconf/ install
    # bug: dss crashes with device-cached.db not found error
    mkdir -p $PREFIX/share/dss/data/databases/
fi

if [ ! -f $PREFIX/share/dss/data/dsscert.pem ]; then
    [ -f dsscert.pem ] || ./tools/create_cert.sh
    cp dsscert.pem $PREFIX/share/dss/data/dsscert.pem
fi

# port forward ds485p from a real target-dss:
#   host: ssh -S none -L8440:127.0.0.1:8440 target-dss

# webroot is wrong

export LD_PRELOAD=/lib/x86_64-linux-gnu/libasan.so.5
gdb --args ./build-autoconf/build/dss --webroot=$PREFIX/share/dss-web/webroot \
     --prop:/config/subsystems/WebServer/listen=127.0.0.1:8088h,0.0.0.0:8081 \
     --prop:/config/subsystems/WebServer/trustedPort=8088 \
     --prop:/config/subsystems/DSBusInterface/connectionURI=tcp://localhost:8440 \
     --prop:/config/loglevel=1


# http://localhost:8080

# if this container is not running on your local machine, you are not able to
# access the web interface, since it only listens on 127.0.0.1
# hence yet make another port forward
#
#   laptop -> build-machine -> dss-container
#
# ssh -S none \
#     -L8088:127.0.0.1:8088 \
#     -L8089:127.0.0.l:8089 \
#     build-machine
