/*
    Copyright (c) 2020 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
*/
#pragma once

#include <ds/asio/resource.h>

namespace dsApartment {

struct ApiRevisionConfigDomain {
  int default_{};
  int min{};
  int max{};
};

struct ApiRevisionConfig {
  ApiRevisionConfigDomain additions;
  ApiRevisionConfigDomain removals;
};

struct ApiRevision : boost::noncopyable {
  virtual ~ApiRevision() = default;
  virtual int additions() const = 0;
  virtual int removals() const = 0;
};

std::unique_ptr<ApiRevision> makeApiRevision(ds::asio::ResourceBase&);

} // namespace dsApartment

DS_JSON_DECLARE_STRUCT((dsApartment), ApiRevisionConfigDomain, (default_)(min)(max));
DS_JSON_DECLARE_STRUCT((dsApartment), ApiRevisionConfig, (additions)(removals));
