// Generated file.  DO NOT EDIT!
// source: api-revision.yaml

// clang-format off

#pragma once


/// Api-revision
///
/// Smarthome Api maintains 2 revision fields:
///   - additions - increased every time api is changed in backwards compatible way - e.g. added resource, added field, added enum option
///   - removals - increased every time api is changed in backwards incompatible way - e.g. , removed resource, removed field, removed enum option
///
/// Both backend and client (app) maintain their api revisions, and take certain actions upon comparation results:
///   - server.additions >= client.additions - fine
///   - server.additions < client.additions - client shall require server update or it may gracefully disable newly added functionality and suggest server update.
///   - server.removals <= client.removals - fine
///   - server.removals > client.removals - client shall require or suggest client update.
///
/// ## Revisions:
///
/// ### additions:4 - applicationTokens
///
/// - added applicationTokens endpoint
///
/// ### additions:3 - apartment#applications2, ventilationUnit
///
/// - added ApartmentApplications - field name is `applications2` due to conflict with old implementation of `applications`
/// - added [apartment#applications2/ventilationUnit]
///
/// ### additions:2 - apiRevision
///
/// - added `apiRevision`
/// - renamed `ControllerMeteringOrigin#type`: `dsMeter` -> `controller`. Technically breaking change but no known client uses it.
///
/// ### additions:1 - measurements, signals, zone#applications2
///
/// - added `measurements`
/// - added `signals`
/// - added [zone#applications2/ventilation](#tag/Groups/paths/~1zones/get)
/// - added [zone#applications2/recirculation](#tag/Groups/paths/~1zones/get)
/// - added [zone#applications2/temperature](#tag/Groups/paths/~1zones/get) - replacement for `applications#type=temperatureApplication`
///
/// ### removals:1 - removed applications
///
/// - removed `applications` in favour of [zone#applications2](#tag/Groups/paths/~1zones/get)
/// - removed `zone#applications` in favour of [zone#applicationTypes](#tag/Groups/paths/~1zones/get)
///
/// ### additions:0, removals:0 - status quo in DSS release R2002
///
/// Status quo in release 2002. Resource object /apiRevisions is not available
///
/// ## DSS releases
///
/// - R2011: additions:4 removals:0 {min:0, max:1}
/// - R2008: additions:3 removals:0 {min:0, max:1}
/// - R2006: additions:2 removals:0 {min:0, max:1}
/// - R2004: additions:1 removals:0 (apiRevision not available)
/// - R2002: additions:0 removals:0 (apiRevision not available)

#include "api-revision-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>


#include <ds/json.h>

namespace dsModel {
struct ApiRevisionAttributes {

  /// newly introduced features
  std::optional<int> additions{};

  /// removed features, breaking changes
  std::optional<int> removals{};

  ~ApiRevisionAttributes();
};

struct ApiRevision {
  ApiRevisionId id{};

  /// Example: apiRevision
  std::string type{};
  ds::DateTime lastChanged{};
  ApiRevisionAttributes attributes{};

  ~ApiRevision();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), ApiRevisionAttributes,
    (additions)
    (removals)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApiRevision,
    (id)
    (type)
    (lastChanged)
    (attributes)
);

