// Generated file.  DO NOT EDIT!
// source: groups.yaml

// clang-format off

#pragma once


/// Groups
///
/// Zones, clusters, applications, etc

#include "groups-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "devices-fwd.h"
#include "installation-fwd.h"
#include "scenarios-fwd.h"
#include "scenarios.h"

#include <ds/json.h>

DS_REFLECTED_ENUM((dsModel), ZoneApplicationType,
    (none)
    (lights)
    (shades)
    (awnings)
    (audio)
    (video)
    (security)
    (access)
    (heating)
    (cooling)
    (temperature)
    (ventilation)
    (recirculation)
    (window)
    (joker)
);

DS_REFLECTED_ENUM((dsModel), AreaApplicationType,
    (none)
    (lights)
    (shades)
);

DS_REFLECTED_ENUM((dsModel), ClusterApplicationType,
    (none)
    (lights)
    (shades)
    (awnings)
    (audio)
    (video)
    (heating)
    (cooling)
    (ventilation)
    (recirculation)
);

DS_REFLECTED_ENUM((dsModel), TemperatureLevel,
    (none)
    (heatingOff)
    (heatingComfort)
    (heatingEconomy)
    (heatingSetback)
    (heatingNight)
    (heatingVacation)
    (coolingOff)
    (coolingComfort)
    (coolingEconomy)
    (coolingSetback)
    (coolingNight)
    (coolingVacation)
    (passiveCoolingThreshold)
);

DS_REFLECTED_ENUM((dsModel), LightsStatusStatus,
    (none)
    (off)
    (on)
    (dimming)
);

DS_REFLECTED_ENUM((dsModel), ShadesStatusStatus,
    (none)
    (closed)
    (open)
    (moving)
    (mixed)
);

DS_REFLECTED_ENUM((dsModel), AwningsStatusStatus,
    (none)
    (in)
    (out)
    (moving)
    (mixed)
);

DS_REFLECTED_ENUM((dsModel), AudioStatusStatus,
    (none)
    (powerOff)
    (standby)
    (off)
    (playing)
    (pause)
    (stop)
);

DS_REFLECTED_ENUM((dsModel), VideoStatusStatus,
    (none)
    (powerOff)
    (standby)
    (off)
    (playing)
    (pause)
    (stop)
);

DS_REFLECTED_ENUM((dsModel), VentilationLevel,
    (none)
    (off)
    (level1)
    (level2)
    (level3)
    (level4)
    (boost)
);

DS_REFLECTED_ENUM((dsModel), TemperatureMode,
    (none)
    (off)
    (automatic)
    (heating)
    (cooling)
);

DS_REFLECTED_ENUM((dsModel), TemperatureStatusStatus,
    (none)
    (off)
    (heating)
    (cooling)
    (neutral)
);


/// Room temperature scene
DS_REFLECTED_ENUM((dsModel), TemperatureScene,
    (none)
    (heatingOff)
    (heatingComfort)
    (heatingEconomy)
    (heatingSetback)
    (heatingNight)
    (heatingVacation)
    (passiveCoolingActive)
    (passiveCoolingInactive)
    (coolingOff)
    (coolingComfort)
    (coolingEconomy)
    (coolingSetback)
    (coolingNight)
    (coolingVacation)
);

namespace dsModel {

struct Area {
  std::string id{};
  std::optional<std::string> name{};
};

struct ZoneApplicationAttributes {
  ZoneApplicationType id{};
  std::vector<Area> areas{};
};

struct Ventilation {
  std::vector<VentilationLevel> availableLevels{};

  ~Ventilation();
};

struct TemperatureSetpoint {
  TemperatureLevel id{};

  /// Room target temperature in degree Celsius
  std::optional<double> value{};

  ~TemperatureSetpoint();
};

struct Temperature {
  std::vector<TemperatureLevel> availableLevels{};
  std::vector<TemperatureSetpoint> setpoints{};

  ~Temperature();
};

struct ZoneApplications {
  std::optional<Ventilation> ventilation{};
  std::optional<Ventilation> recirculation{};
  std::optional<Temperature> temperature{};

  ~ZoneApplications();
};

struct ZoneAttributes {

  /// User given name
  ///
  /// Example: Kitchen
  std::string name{};
  FloorId floor{};

  /// Order id used for sorting
  ///
  /// Example: 20
  std::optional<double> orderId{};

  /// List of submodule ids assigned in this zone
  std::vector<SubmoduleId> submodules{};

  /// List of existing Application Types in this zone (deprecated in favour of applicationTypes)
  std::vector<ZoneApplicationType> applications{};
  ZoneApplications applications2{};

  /// List of existing Application Types in this zone
  std::vector<ZoneApplicationType> applicationTypes{};
  std::vector<ZoneApplicationAttributes> applicationDetails{};
  std::vector<ScenarioId> scenarios{};

  ~ZoneAttributes();
};

struct Zone {
  ZoneId id{};
  std::string type = "zone";
  ds::DateTime lastChanged{};
  ZoneAttributes attributes{};

  ~Zone();
};

struct Zones {
  std::vector<Zone> zones{};

  ~Zones();
};

struct ZoneMeasurementsStatus {

  /// Room temperature in degree Celsius
  ///
  /// Example: 21.4
  std::optional<double> temperature{};

  /// Relative Humidity in %rH
  ///
  /// Example: 42
  std::optional<double> humidity{};

  /// Brightness in lux
  ///
  /// Example: 750
  std::optional<double> brightness{};

  /// CO2 level in ppm
  ///
  /// Example: 1230
  std::optional<double> carbonDioxide{};

  /// Motion status in the zone
  std::optional<bool> motion{};

  /// Presence status in the zone
  std::optional<bool> presence{};

  /// Open window or door to the outside
  std::optional<bool> openWindowDoor{};

  ~ZoneMeasurementsStatus();
};

struct LightsStatus {
  LightsStatusStatus status{};
  LightsStatusStatus nonLocalPriority{};
  LightsStatusStatus area1{};
  LightsStatusStatus area2{};
  LightsStatusStatus area3{};
  LightsStatusStatus area4{};

  ~LightsStatus();
};

struct ShadesStatus {
  ShadesStatusStatus status{};
  ShadesStatusStatus nonLocalPriority{};
  ShadesStatusStatus area1{};
  ShadesStatusStatus area2{};
  ShadesStatusStatus area3{};
  ShadesStatusStatus area4{};

  ~ShadesStatus();
};

struct AwningsStatus {
  AwningsStatusStatus status{};

  ~AwningsStatus();
};

struct AudioStatus {
  AudioStatusStatus status{};
  AudioStatusStatus nonLocalPriority{};
  std::optional<bool> muted{};
  std::optional<double> volume{};

  ~AudioStatus();
};

struct VideoStatus {
  VideoStatusStatus status{};
  VideoStatusStatus nonLocalPriority{};
  std::optional<bool> muted{};
  std::optional<double> volume{};

  ~VideoStatus();
};

struct VentilationStatus {
  VentilationLevel level{};
  std::optional<bool> malfunction{};
  std::optional<bool> serviceRequired{};

  ~VentilationStatus();
};

struct TemperatureStatus {
  TemperatureMode mode{};
  TemperatureStatusStatus status{};

  /// Is temperature control in emergency mode? (e.g. missing temperature)
  std::optional<bool> emergency{};

  /// Room target temperature in degree Celsius
  std::optional<double> setpoint{};

  /// Room temperature control value in percent
  std::optional<double> controlValue{};
  TemperatureScene lastCalledScene{};

  /// Did user select setback?
  std::optional<bool> setbackRequested{};

  /// Did user select to prefer eco over comfort by default?
  std::optional<bool> ecoPreferred{};

  /// Did user select to enable/disable passive cooling for this zone only? It can override global setting.
  std::optional<bool> passiveCooling{};

  ~TemperatureStatus();
};

//
// serialized to json as array by id
struct ZoneApplicationsStatus {
  LightsStatus lights{};
  ShadesStatus shades{};
  AwningsStatus awnings{};
  AudioStatus audio{};
  VideoStatus video{};
  VentilationStatus ventilation{};
  VentilationStatus recirculation{};
  TemperatureStatus temperature{};

  ~ZoneApplicationsStatus();
};

struct ZoneStatusAttributes {
  ZoneMeasurementsStatus measurements{};
  ZoneApplicationsStatus applications{};
  std::vector<ScenarioStatus> scenarios{};

  ~ZoneStatusAttributes();
};

struct ZoneStatus {
  ZoneId id{};
  std::string type = "zoneStatus";
  ds::DateTime lastChanged{};
  ZoneStatusAttributes attributes{};

  ~ZoneStatus();
};

struct ZoneStatuses {
  std::vector<ZoneStatus> zones{};

  ~ZoneStatuses();
};

struct ClusterAttributes {

  /// User given name
  ///
  /// Example: Kitchen
  std::string name{};
  std::optional<int> orderId{};
  ClusterApplicationType applicationType{};
  std::vector<SubmoduleId> submodules{};

  ~ClusterAttributes();
};

struct Cluster {
  ClusterId id{};
  std::string type = "cluster";
  ds::DateTime lastChanged{};
  ClusterAttributes attributes{};

  ~Cluster();
};

struct Clusters {
  std::vector<Cluster> clusters{};

  ~Clusters();
};

struct ClusterWeatherStatus {
  std::optional<bool> wind{};
  std::optional<bool> hail{};

  ~ClusterWeatherStatus();
};

struct ClusterStatusAttributes {
  ClusterWeatherStatus weather{};
  std::optional<bool> operationsLocked{};

  ~ClusterStatusAttributes();
};

struct ClusterStatus {
  ClusterId id{};
  std::string type = "clusterStatus";
  ds::DateTime lastChanged{};
  ClusterStatusAttributes attributes{};

  ~ClusterStatus();
};

struct ClusterStatuses {
  std::vector<ClusterStatus> clusters{};

  ~ClusterStatuses();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), Area,
    (id)
    (name)
);

DS_JSON_DECLARE_STRUCT((dsModel), ZoneApplicationAttributes,
    (id)
    (areas)
);

DS_JSON_DECLARE_STRUCT((dsModel), Ventilation,
    (availableLevels)
);
DS_JSON_DECLARE_STRUCT((dsModel), TemperatureSetpoint,
    (id)
    (value)
);
DS_JSON_DECLARE_STRUCT((dsModel), Temperature,
    (availableLevels)
    (setpoints)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneApplications,
    (ventilation)
    (recirculation)
    (temperature)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneAttributes,
    (name)
    (floor)
    (orderId)
    (submodules)
    (applications)
    (applications2)
    (applicationTypes)
    (applicationDetails)
    (scenarios)
);
DS_JSON_DECLARE_STRUCT((dsModel), Zone,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), Zones,
    (zones)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneMeasurementsStatus,
    (temperature)
    (humidity)
    (brightness)
    (carbonDioxide)
    (motion)
    (presence)
    (openWindowDoor)
);
DS_JSON_DECLARE_STRUCT((dsModel), LightsStatus,
    (status)
    (nonLocalPriority)
    (area1)
    (area2)
    (area3)
    (area4)
);
DS_JSON_DECLARE_STRUCT((dsModel), ShadesStatus,
    (status)
    (nonLocalPriority)
    (area1)
    (area2)
    (area3)
    (area4)
);
DS_JSON_DECLARE_STRUCT((dsModel), AwningsStatus,
    (status)
);
DS_JSON_DECLARE_STRUCT((dsModel), AudioStatus,
    (status)
    (nonLocalPriority)
    (muted)
    (volume)
);
DS_JSON_DECLARE_STRUCT((dsModel), VideoStatus,
    (status)
    (nonLocalPriority)
    (muted)
    (volume)
);
DS_JSON_DECLARE_STRUCT((dsModel), VentilationStatus,
    (level)
    (malfunction)
    (serviceRequired)
);
DS_JSON_DECLARE_STRUCT((dsModel), TemperatureStatus,
    (mode)
    (status)
    (emergency)
    (setpoint)
    (controlValue)
    (lastCalledScene)
    (setbackRequested)
    (ecoPreferred)
    (passiveCooling)
);
template <>
struct DSJsonStructTrait<dsModel::ZoneApplicationsStatus> {
  static constexpr auto mode = ds::JsonStructMode::idArrayObject;
};
DS_JSON_DECLARE_STRUCT((dsModel), ZoneApplicationsStatus,
    (lights)
    (shades)
    (awnings)
    (audio)
    (video)
    (ventilation)
    (recirculation)
    (temperature)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneStatusAttributes,
    (measurements)
    (applications)
    (scenarios)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneStatus,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), ZoneStatuses,
    (zones)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClusterAttributes,
    (name)
    (orderId)
    (applicationType)
    (submodules)
);
DS_JSON_DECLARE_STRUCT((dsModel), Cluster,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), Clusters,
    (clusters)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClusterWeatherStatus,
    (wind)
    (hail)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClusterStatusAttributes,
    (weather)
    (operationsLocked)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClusterStatus,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClusterStatuses,
    (clusters)
);

