#pragma once

#include <vector>

namespace ds {
// Makes vector from a range. Until std::vector gains range constructor (C++23?)
template <class Range>
auto makeVector(Range&& range) {
  auto result = std::vector<std::decay_t<decltype(*std::begin(range))>>{};
  result.reserve(std::size(range));
  for (auto&& item : std::forward<Range>(range)) {
    result.push_back(std::forward<decltype(item)>(item));
  }
  return result;
};

// TODO(someday): template magic / if constexpr to automatically select
template <class Range>
auto makeVectorNoReserve(Range&& range) {
  auto result = std::vector<std::decay_t<decltype(*std::begin(range))>>{};
  for (auto&& item : std::forward<Range>(range)) {
    result.push_back(std::forward<decltype(item)>(item));
  }
  return result;
};

} // namespace ds
