#pragma once

#include <ds/json.h>
#include <ds/system.h>

//#include "config.hpp"

namespace dss::modbus {

struct ModbusMiscConfig {
  std::string modbusTCPServer;
  int port;
  int readIntervalUSec;
  int timeoutResponseSec;
  int timeoutIndicationSec;
};

struct ConfigFile {
  ModbusMiscConfig modbusMiscConfig{};
};

ConfigFile loadConfigFile(ds::System&);

} // namespace dss::modbus

DS_JSON_DECLARE_STRUCT((dss::modbus), ModbusMiscConfig, (modbusTCPServer)(port)(readIntervalUSec)(timeoutResponseSec)(timeoutIndicationSec));
DS_JSON_DECLARE_STRUCT((dss::modbus), ConfigFile, (modbusMiscConfig));
