/*
    Copyright (c) 2010 digitalSTROM.org, Zurich, Switzerland

    Author: Patrick Staehlin, futureLAB AG <pstaehlin@futurelab.ch>

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include "datetools.h"

namespace dss {

class PhysicalModelItem {
private:
  bool m_isPresent = false;
  bool m_isConnected = false;
  DateTime m_inactiveSince = DateTime::NullDate;

public:
  PhysicalModelItem();
  virtual ~PhysicalModelItem();

  bool isPresent() const; // isPresent && isConnected

  virtual void setIsPresent(bool value);
  void setInactiveSince(DateTime value);

  DateTime getInactiveSince() const { return m_inactiveSince; }
  std::string getInactiveSinceStr() const { return m_inactiveSince.toString(); }

  bool isConnected() const { return m_isConnected; }
  virtual void setIsConnected(bool value);
};

} // namespace dss
