/*
 *  Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of digitalSTROM Server.
 *
 *  digitalSTROM Server is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  digitalSTROM Server is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <trompeloeil.hpp>
#include "propertysystem.h"

namespace dss {

class PropertySystemMock : public trompeloeil::mock_interface<PropertySystem> {
public:
  MAKE_CONST_MOCK1(getProperty, PropertyNodePtr(const std::string&), override);
  MAKE_CONST_MOCK1(getStringValue, std::string(const std::string&), override);
};

class PropertyNodeMock : public trompeloeil::mock_interface<PropertyNode> {
public:
  MAKE_MOCK1(getChild, PropertyNodePtr(const int), override);
  MAKE_CONST_MOCK0(getChildCount, int(), override);
  MAKE_MOCK1(getPropertyByName, PropertyNodePtr(const std::string&), override);
  MAKE_MOCK1(getProperty, PropertyNodePtr(const std::string&), override);
  MAKE_CONST_MOCK0(getIntegerValue, int(), override);
  MAKE_CONST_MOCK0(getBoolValue, bool(), override);
  MAKE_CONST_MOCK0(getStringValue, std::string(), override);
};

}
